<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema"
	xmlns:ve="http://schemas.openxmlformats.org/markup-compatibility/2006"
	xmlns:o="urn:schemas-microsoft-com:office:office"
	xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships"
	xmlns:m="http://schemas.openxmlformats.org/officeDocument/2006/math"
	xmlns:v="urn:schemas-microsoft-com:vml"
	xmlns:wp="http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing"
	xmlns:w10="urn:schemas-microsoft-com:office:word"
	xmlns:w="http://schemas.openxmlformats.org/wordprocessingml/2006/main"
	xmlns:wne="http://schemas.microsoft.com/office/word/2006/wordml"
	xmlns:pic="http://schemas.openxmlformats.org/drawingml/2006/picture"
	xmlns:a="http://schemas.openxmlformats.org/drawingml/2006/main"
	xmlns:fn="http://www.pageseeder.com/function" xmlns:dec="java:java.net.URLDecoder">

	<xsl:param name="psstyles" />
	<xsl:param name="wordstyles" />

	<xsl:variable name="ps-styles"
		select="document(concat('file:///',replace($psstyles, '\\', '/')))" />
	<xsl:variable name="word-styles"
		select="document(concat('file:///',replace($wordstyles, '\\', '/')))" />


	<xsl:template match="/">
		<xsl:apply-templates />
	</xsl:template>

	<xsl:template match="w:styles">
		<xsl:copy>
			<xsl:copy-of select="@*" />
			<xsl:for-each select="$ps-styles/ps-styles/*[@id != $word-styles/styles/style/@id]">
				<w:style w:type="{if (name() = 'paraLabel') then 'paragraph' else 'character'}" w:styleId="{@id}">
					<w:name w:val="{@id}" />
					<w:basedOn w:val="Normal" />
					<xsl:choose>
					  <xsl:when test="name() = 'paraLabel'">
					    <w:pPr>
                <w:pBdr>
		              <w:top w:val="single" w:sz="4" w:space="1" w:color="8DB3E2" w:themeColor="text2" w:themeTint="66" />
		              <w:left w:val="single" w:sz="4" w:space="4" w:color="8DB3E2" w:themeColor="text2" w:themeTint="66" />
		              <w:bottom w:val="single" w:sz="4" w:space="1" w:color="8DB3E2" w:themeColor="text2" w:themeTint="66" />
		              <w:right w:val="single" w:sz="4" w:space="4" w:color="8DB3E2" w:themeColor="text2" w:themeTint="66" />
                </w:pBdr>
              </w:pPr>
					  </xsl:when>
					  <xsl:otherwise>
					    <w:rPr><w:bdr w:val="single" w:sz="4" w:space="0" w:color="D99594" w:themeColor="accent2" w:themeTint="99"/></w:rPr>
					  </xsl:otherwise>  
					</xsl:choose>
				</w:style>
			</xsl:for-each>
			<xsl:apply-templates />
		</xsl:copy>
	</xsl:template>

	<!-- standard copy template -->
	<xsl:template match="@*|node()">
		<xsl:copy>
			<xsl:apply-templates select="@*" />
			<xsl:apply-templates />
		</xsl:copy>
	</xsl:template>
</xsl:stylesheet>